PROGRAM PAW2NMP;

USES Z80LOAD;


{$I-}

CONST Version = '0.0.1';
      MAXTVOC=6;

VAR Spectrum : ARRAY [16384..65535] OF Byte;
    FOut : Text;
    F : File;
    FSize : Longint;
    VocPtr, ConPtr, ProPtr, ResPtr : Word;
    i, n, p : Integer;
    InputFileName, OutPutFileName : String;
    OffAbreviaturas: Word;
    OffVoc, offcon, OffMsg, OffSys, OffLoc, OffObj, OffWObj,
    OffLObj, OffXObj, OffPro: Word;
    NumLoc, NumMsg, NumSys, NumObj, NumPro : Integer ;
    AbrevOn:Boolean;
    S:String;

FUNCTION DPeek(C:Word):Word;
BEGIN
 DPeek := spectrum[c] OR (spectrum[c+1] SHL 8);
END;

FUNCTION Peek(C:Word):Byte;
BEGIN
 Peek := Spectrum[c];
END;

FUNCTION PeekNeg(C:Word):Byte;
BEGIN
 PeekNeg := Spectrum[c] XOR 255;
END;

FUNCTION Select(Option:Boolean;S1,S2:String):String;
(* emula operador ? de C *)
BEGIN
 IF Option THEN Select:=S1
           ELSE Select:=S2;
END;

FUNCTION Justify(S : String; N: Byte) : String;
BEGIN
 WHILE Length(S)<N DO S:=S+' ';
 JustiFy := S;
END;

FUNCTION IntToStr(L:Longint):String;
VAR S : String;
BEGIN
 Str(L,S);
 IntToStr := S
END;

PROCEDURE Error(n:Byte);
BEGIN
 IF N<>0 THEN Write('Error: ');
 CASE N OF
  1:WriteLn('Fichero no se encontr.');
  2:WriteLn('Debe ser un fichero .SP, .SNA o .Z80');
  3:WriteLn('No parece ser un programa PAW.');
  4:WriteLn('Falta parmetro.');
  5:WriteLn('Fichero .Z80 no vlido.');
  6:WriteLn('Slo se admiten ficheros .Z80 de 48k.');
 END;
 Halt(n)
END;

{$I DATA.INC}


FUNCTION Abreviatura(c:Integer) : String;
VAR Offs: Word;
    S:String;
BEGIN
 S:='';
 Offs:=OffAbreviaturas;
 Dec(c,$A4);
 WHILE c<>0 DO
  BEGIN
   WHILE (Spectrum[Offs] AND $80) = 0 DO Inc(Offs);
   Inc(Offs);
   Dec(c);
  END;
  WHILE (Spectrum[Offs] AND $80) = 0 DO BEGIN
                                         S := S + Char(Spectrum[Offs]);
                                         Inc(Offs);
                               END;
  S := S + Char(Spectrum[Offs] AND $7F);
  Abreviatura:= S;
END;

FUNCTION Tipo_Voc(C:Integer):String;
BEGIN
 IF (C>=0) AND (C<=MAXTVOC) then Tipo_Voc:=TVocs[c]
                            else Tipo_Voc:='RESERVADO';
END;

FUNCTION Palabra(Num, Tipo : Integer) : String;
VAR VocPtr: Word;
    Pal:String;
BEGIN
 VocPtr:=OffVoc;
 Pal[0]:=#5;
 WHILE Peek(VocPtr)<>0 do
  BEGIN
   IF (Peek(vocptr+5) = Num) AND (Peek(vocptr+6) = Tipo) THEN
    BEGIN
     pal[1]:=char(PeekNeg(VocPtr));
     pal[2]:=char(PeekNeg(VocPtr+1));
     pal[3]:=char(PeekNeg(VocPtr+2));
     pal[4]:=char(PeekNeg(VocPtr+3));
     pal[5]:=char(PeekNeg(VocPtr+4));
     Palabra:=Pal;
     Exit;
    END;
   Inc(VocPtr,7);
  END;
 Palabra:='';
END;

PROCEDURE Ver_String(S : String);
VAR I:Byte;
BEGIN
 FOR I:=1 TO Length(S) DO
  BEGIN
   IF S[I]=#7 THEN Write(FOut,'^') ELSE
   IF (S[I]>#31) AND (S[I]<>'^')
     AND (S[I]<>'"') AND (S[I]<#$A4)
      THEN Write(FOut,S[I])
      ELSE Write(FOut,'{',Byte(S[I]),'}');
  END;
END;

PROCEDURE Ver_Mensajes(Titulo:String; Offtab:Word; Num:Integer);
VAR I:Integer;
    C: Byte;
    Offs:Word;
BEGIN
 I:=0;
 WHILE I<Num DO
  BEGIN
   Offs:=DPeek(OffTab+2*i);
   WriteLn(FOut,Titulo,i,'}');
   Write(FOut,'{');
   Inc(I);
   WHILE (Spectrum[Offs] <> ($1F XOR $FF)) AND (Offs<$FFF0) DO
    BEGIN
     C:=PeekNeg(Offs);
     Inc(Offs);
     IF C=7 THEN Write(FOut,'^');
     IF (C>31) AND (C<>byte('^'))
      AND (C<>Byte('"')) AND (C<$A4) THEN Write(FOut,Char(c)) ELSE
     IF (C>=$A4) AND (C<=$FF) THEN Ver_String(Abreviatura(c))
                              ELSE Write(FOut,'[',C,']');

    END;
   Inc(Offs);
   WriteLn(FOut,'}');
   WriteLn(FOut);
  END;
END;



FUNCTION UpSt(S:String):String;
VAR I:Byte;
BEGIN
 FOR I:=1 TO Length(S) DO
  S[I]:=UpCase(S[I]);
 UpSt:=S;
END;


PROCEDURE Sintax;
BEGIN
 WriteLn;
 WriteLn('SINTAXIS:  PAW2NMP <filename>');
 WriteLn;
 WriteLn('El fichero debe ser un fichero .SP, .SNA o .Z80');
 WriteLn;
 Halt;
END;

PROCEDURE CheckParameters;
BEGIN
 IF ParamCount=0 THEN Sintax;
 InputFileName := ParamStr(1);
END;


BEGIN (* main *)
 WriteLn('PAW2NMP ',Version);

 (* Cargar parmetros *)
 CheckParameters;

 (* Cargar fichero *)
 Assign(F,InputFileName);
 Reset(F,1);
 IF IOResult<>0 THEN Error(1);
 FSize:=FileSize(F);
 IF FSize=49179 THEN
         BEGIN
          Seek(F,$1C1B);
          BlockRead(F,Spectrum[$5C00],$A400);
         END ELSE
 IF FSize=49190 THEN
         BEGIN
          Seek(F,$1C26);
          BlockRead(F,Spectrum[$5C00],$A400);
         END
  ELSE IF Pos('.Z80',InPutFileName)<>0 THEN CASE LoadZ80(InputFileName,Spectrum) OF
                                             1:Error(5);
                                             2:Error(6);
                                            END
  ELSE Error(2);
 Close(F);

 (* Comienza el anlisis *)

 IF Peek($9437) <> $10 THEN Error(3);


 (* Crear Subdirectorio *)
 MKDIR('NMP');
 if IOResult=0 then;

 (* Abrir fichero de salida *)
 Assign(FOut,'NMP\V.DEF');
 Rewrite(FOut);
 WriteLn(FOut,'; PAW2NMP ',version,' : Fichero de Vocabulario');
 WriteLn(FOut);



 (* Variables globales *)
 OffMsg:=DPeek($FFDF);
 NumMsg:=Peek($9446);
 OffSys:=DPeek($FFE1);
 NumSys:=Peek($9447);
 OffLoc:=DPeek($FFDD);
 NumLoc:=Peek($9445);
 OffObj := DPeek($FFDB);
 NumObj := Peek($9444);
 NumPro := Peek($9448) ;
 OffPro := DPeek($FFD9) ;
 OffAbreviaturas := DPeek($944C) ;

 WriteLn;
 WriteLn('Analizando [',Copy(InputFileName,1,Pos('.',InputFileName)-1),']');

 WriteLn('Extrayendo vocabulario');
 (* Extrae el vocabulario *)

 vocptr := DPeek($FFE5);
 OffVoc := DPeek($FFE5);

 WHILE (vocptr < $FFE5) AND  (Peek(vocptr)<>0) DO
 BEGIN
  if not (char(PeekNeg(vocPtr)) in ['*','_']) then
  Write(FOut,'{',char(PeekNeg(vocptr)),char(PeekNeg(vocptr+1)),
         char(PeekNeg(vocptr+2)),char(PeekNeg(vocptr+3)),char(PeekNeg(vocptr+4)),',',
         tipo_voc(Peek(vocptr+6)),',',Peek(vocptr+5),'}',#10#13) ;
  VocPtr := VocPtr + 7 ;
 END;
 WriteLn(FOut);
 Close(FOut);

 Assign(FOut,'NMP\M.DEF');
 Rewrite(FOut);
 WriteLn(FOut,'; PAW2NMP ',version,' : Fichero de Mensajes');
 WriteLn(FOut);
 (* Extrae mensajes *)
 WriteLn('Extrayendo ',NumMsg, ' mensaje(s)');
 WriteLn(FOut,'; Mensajes de usuario ');
 Ver_mensajes ('{1,',OffMsg, nummsg);
 WriteLn(FOut);
 WriteLn(FOut);
 WriteLn(FOut,'; Mensajes del sistema de PAW ');
 Ver_mensajes ('{2,',OffSys, NumSys);
 WriteLn(FOut,'}');
 Close(FOUT);

{ WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Extrae nombres de localidad *)
 Write(FOut,'LOCALIDADES'#10#13'--------------------'#10#13);
 WriteLn('Extrayendo ',NumLoc,' localidad(es)');
 Ver_mensajes ('Localidad', offloc, NumLoc) ;
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Extrae conexiones *)
 Write(FOut,'CONEXIONES'#10#13'----------'#10#13) ;
 WriteLn('Extrayendo conexiones');
 offcon := DPeek($FFE3) ;
 FOR i:=0 TO numloc-1 DO
  BEGIN
   conptr := DPeek(offcon+2 * i) ;
   n := 0 ;
   WHILE Peek(conptr) <> $FF DO
     BEGIN
      S := palabra(Peek(conptr), 0);
      if S='' then S := palabra (Peek(conptr), 2) ;
      if n=0 THEN Write(FOut,'Localidad ',i:3,':  ')
             ELSE Write(FOut,'                ') ;
      n := n+ 1;
      if S<>'' then Write(FOut,S,' ',Peek(conptr+1),#10#13)
               else Write(FOut,Peek(conptr),' ',Peek(conptr+1),#10#13);
      conptr :=conptr+ 2 ;
     END;
     IF n<>0 THEN WriteLn(FOut);
  END;

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Extrae nombres de objeto *)
 Write(FOut,'NOMBRES DE OBJETO'#10#13'-----------------'#10#13);
 WriteLn('Extrayendo ',NumObj,' objeto(s)');
 ver_mensajes ('Objeto',OffObj , NumObj);
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Extrae palabras de objeto *)
 WriteLn('Extrayendo palabras de objeto');
 Write(FOut,'PALABRAS DE OBJETO'#10#13'------------------'#10#13) ;
 offwobj := DPeek($FFE9) ;
 FOR I:=0 TO NumObj-1 DO
 BEGIN
     S := palabra(Peek(offwobj+2*i), 2) ;
     if S<>'' THEN S:=S + ' ' + IntToStr(Peek(offwobj+2*i));
     if (Peek(offwobj+2*i) = $FF) THEN S:=S+'_    ' ;
     Write(FOut,'Objeto ',i:3,'    ',S,' ') ;
     S := palabra(Peek(offwobj+2*i+1), 3) ;
     if S<>'' THEN S := S + ' '+IntToStr( Peek(offwobj+2*i+1));
     if (Peek(offwobj+2*i+1) = $FF) then S := S+'_    ';
     Write(FOut,S,#10#13) ;
 END;
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Extrae posiciones de objeto *)
 WriteLn('Extrayendo posiciones iniciales de objeto');
 Write(FOut,'POSICIONES INICIALES DE OBJETO'#10#13'------------------------------'#10#13);
 OffLObj := DPeek($FFE7) ;
 for i:=0 TO NumObj-1 DO
   CASE (Peek(offlobj+i)) OF
    252:Write(FOut,'Objeto ',i:3,'    NO CREADO'#10#13);
    253:Write(FOut,'Objeto ',i:3,'    PUESTO'#10#13);
    254:Write(FOut,'Objeto ',i:3,'    LLEVADO'#10#13)
    ELSE Write(FOut,'Objeto ',i:3,'    LOCALIDAD ',Peek(offlobj+i),#10#13);
   END;
 WriteLn(FOut);

 WriteLn(FOut,'--------------------------------------------------------------------------');
 WriteLn(FOut);
 (* Extrae peso de objeto *)
 WriteLn('Extrayendo peso y tipo de objetos');
 Write(FOut,'PESO Y TIPO DE OBJETO'#10#13'---------------------'#10#13) ;
 offxobj := DPeek($FFEB) ;
 for I:=0 TO NumObj-1 DO
    Write(FOut,'Objeto ',i:3,':  pesa ',
      Peek(offxobj+i) AND $3F:3,'    ',
       Select((Peek(offxobj+i) AND $40)<>0,'Contenedor','          '),' ',
        Select((Peek(offxobj+i) AND $80)<>0,'Prenda','      '),#10#13);
 WriteLn(FOut);


 (* Extrae procesos *)
 WriteLn('Extrayendo Tablas de Procesos/Respuestas');
 FOR P:=0 TO NumPro-1 DO
 BEGIN
  WriteLn(FOut,'--------------------------------------------------------------------------');
  WriteLn(FOut);
  IF (p=0) THEN BEGIN
                 WriteLn(FOut,'TABLA DE RESPUESTAS');
                 WriteLn(FOut,'-------------------')
                END
           ELSE BEGIN
                 WriteLn(FOut,'PROCESO ',p:3);
                 WriteLn(FOut,'-----------');
                END;

   proptr := DPeek(offpro+p*2) ;
   while (Peek(proptr)<>0) DO
     BEGIN
         S := palabra (Peek(proptr), 0) ;
         if (Peek(proptr) = 1) then S := S + '*    '
         else
         if (Peek(proptr) = $FF) then S := S + '_    ';
         if S='' THEN
          BEGIN
             if (Peek(proptr) < 20) then
                 S := palabra(Peek(proptr), 2);
             if S = '' THEN S := IntToStr(Peek(proptr)) ;
          END;
         Write(FOut,S,' ') ;
         proptr := proptr + 1 ;
         S := palabra (Peek(proptr), 2) ;
         if (Peek(proptr) = 1) then S := S + '*    '
         else
         if (Peek(proptr) = $FF) then S := S + '_    ';
         if S = '' THEN
          BEGIN
             if (Peek(proptr) < 20) then
                 S := palabra(Peek(proptr), 2);
             if S='' THEN S:=IntToStr(Peek(proptr)) ;
          END;
         Write(FOut,S,'      ') ;
         proptr := proptr +1 ;

         resptr := DPeek(proptr) ;
         proptr := proptr + 2 ;

         n := 0 ;
         while (Peek(resptr) <> $FF) do
         BEGIN
           if (n<>0) then Write(FOut,'                 ') ;
           n := n + 1;
           if (Peek(resptr) <= $6B) THEN
             BEGIN
                 Write(FOut,Justify(condacts[Peek(resptr)].condact,12));
                 if (condacts[Peek(resptr)].params > 0) THEN
                     Write(FOut,' ',Peek(resptr+1):3);
                 if (condacts[Peek(resptr)].params > 1) THEN
                     Write(FOut,' ',Peek(resptr+2):3);
                 resptr :=resptr + condacts[Peek(resptr)].params;
             END;
             resptr := resptr + 1 ;
             WriteLn(FOut);
         END;
         WriteLn(FOut);
     END;
     WriteLn(FOut);
 END;


 IF AbrevOn THEN
  BEGIN
   WriteLn(FOut,'--------------------------------------------------------------------------');
   WriteLn(FOut);
   (* Extrae abreviaturas *)
   WriteLn('Extrayendo abreviaturas');
   WriteLn(FOut,'Abreviaturas');
   WriteLn(FOut,'------------');
   FOR I:=$A4 TO $FE DO
       WriteLn(FOut,'Abreviatura ',I:2,': ',Abreviatura(I));
   WriteLn(FOut);
  END;

 Close(FOut);}
 WriteLn('Ok. Finalizado.');

END.
